# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2022-09-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictBool, StrictFloat, StrictInt, StrictStr

class PaymentModeDetails(BaseModel):
    """
    payment mode eligiblity object
    """
    nick: Optional[StrictStr] = None
    display: Optional[StrictStr] = None
    eligibility: Optional[StrictBool] = None
    code: Optional[Union[StrictFloat, StrictInt]] = None
    __properties = ["nick", "display", "eligibility", "code"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PaymentModeDetails:
        """Create an instance of PaymentModeDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PaymentModeDetails:
        """Create an instance of PaymentModeDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PaymentModeDetails.parse_obj(obj)

        _obj = PaymentModeDetails.parse_obj({
            "nick": obj.get("nick"),
            "display": obj.get("display"),
            "eligibility": obj.get("eligibility"),
            "code": obj.get("code")
        })
        return _obj


